#include<stdio.h>
#include<stdlib.h>

int ** main_table;
int * flow_table[3];
int * visited1;
int vertices;

typedef struct {
  char c;
  int prev;
} SIGN;
SIGN * sign_table;
SIGN * copy=NULL;
typedef struct front_item{
	int vertex;
	struct front_item * next;
	int distance;
} FRONT_ITEM;

int power(int base, int power);
int front_empty(FRONT_ITEM * front);
void front_print(FRONT_ITEM * begin, char * text);
FRONT_ITEM * front_add(FRONT_ITEM ** begin, FRONT_ITEM * end, int vertex, int distance);
FRONT_ITEM * front_remove(FRONT_ITEM ** begin, FRONT_ITEM ** end);
FRONT_ITEM * front_delete(FRONT_ITEM * begin);
int front_contains(FRONT_ITEM * begin, int vertex);

FRONT_ITEM * front;
FRONT_ITEM * front_begin;
int * visited1;
int **cut;


int * init_vis(int * visited);


void print_flows(){
  int i,j;
  
  for(i=0;i<vertices;i++) 
  	printf("%d ", i%10);
  	
  for(j=0; j<3; j++){  
  	
  	printf("\n");
	  for(i=0;i<vertices;i++){
	  printf("%d ",flow_table[j][i]);
	} 
	
  }
  printf("\n");
}
void print_signs(){
	int j;
	for(j=0; j<vertices; j++){
 		  printf("%d:%c, prev:%d\t ",j,sign_table[j].c,sign_table[j].prev);
	}
	printf("\n\n");
}
void print_copy(){
	int j;
	printf("copy:\n");
	for(j=0; j<vertices; j++){
 		  printf("%d:%c, prev:%d\t ",j,copy[j].c,copy[j].prev);
	}
	printf("\n\n");
}

void search(int vertex, int depth, char c){
	int i;
	if(depth==0) {
	  if (c!='0') sign_table[vertex].c=c;
	  if (c=='s') front=front_add(&front_begin,front,vertex,0);
 
 	}
 	else{
 	  
 	  visited1[vertex]=1;
 	  for(i=0; i<3; i++){
  		if(!(visited1[main_table[i][vertex]])){	
		  sign_table[vertex].c='!';	
		  search(main_table[i][vertex],depth-1, c);
 		}
 	  } 	   	
 	}
 }		 
 
int iteration(int fulltree_a, int fulltree_b, int depth, int * path){
 int i,j;
 
 FRONT_ITEM * pom;
 int vertex;
 int end=0;
 
 while((!front_empty(front)) && (!end)){
 	
 	pom=front_remove(&front_begin,&front);
 	vertex=pom->vertex;
 	free(pom);
 	for(i=0; i<3; i++){
 		if(sign_table[main_table[i][vertex]].c=='x'  && flow_table[i][vertex]<1){
 	
 	      for(j=0; j<3; j++){
 			if(main_table[j][main_table[i][vertex]]==vertex){
 	
 				if(flow_table[j][main_table[i][vertex]]==1) 	
 					sign_table[main_table[i][vertex]].c='-'; 	
  				else
 					sign_table[main_table[i][vertex]].c='+';
 			}
 		  }
 			sign_table[main_table[i][vertex]].prev=vertex; 		 	
 			front=front_add(&front_begin,front,main_table[i][vertex],0);
 	
 		}
 		else{ 
 			if ((sign_table[main_table[i][vertex]].c=='t') && (flow_table[i][vertex]<1)) {
 			  sign_table[main_table[i][vertex]].prev=vertex;
 			  vertex=main_table[i][vertex]; 
 			  end=1;
 		  	  break;					
 			}
 		}
 	  }
 	}

 	 
 int novy;
 if (end){
 	
 	int length=0; 
 	while(!(sign_table[vertex].c=='s')){ 		
 		
 		path[length]=vertex;
 		length++;
 		novy=sign_table[vertex].prev;
 		
 		if (sign_table[vertex].c=='-'){
 		  for(i=0; i<3; i++){ 		  	
 		  	if (novy==main_table[i][vertex]){
 		  		flow_table[i][vertex]=0;
 		  	}
 		  }
 		}
 		   		
 		if (sign_table[vertex].c=='+' || sign_table[vertex].c=='t'){	
  			for(i=0; i<3; i++){ 		  	
 		  	  if (vertex==main_table[i][novy]){
 		  		flow_table[i][novy]=1;
 		  	  }
 		  	} 			
 		}
 		
 		vertex=novy;	
 	}
 	path[length]=vertex;
 	return length;
 }
 else {
 	return 0;
 }
}
int ** findpaths(int fulltree_a, int fulltree_b, int depth, int **paths){
			
    int i,j,k,length;
    for(j=0; j<vertices; j++){
	  	  sign_table[j].c='x';	
	  	  sign_table[j].prev=-1;
	}
	
	visited1=(int*)malloc(vertices*sizeof(int));  
	
	visited1=init_vis(visited1);
    search(fulltree_a,depth,'s');
	visited1=init_vis(visited1);
 	search(fulltree_b,depth,'t');
 	
 	free(visited1);
	i=0;
	
    while((length=iteration(fulltree_a, fulltree_b, depth, paths[i]))){	
     
  	  i++;	
	  front=front_delete(front_begin);
	  for(j=0; j<vertices; j++){
	  	switch(sign_table[j].c){
	  		case '+': sign_table[j].c='x';sign_table[j].prev=-1; break;
	  		case '-': sign_table[j].c='x';sign_table[j].prev=-1; break;
	  		case 't': sign_table[j].prev=-1; break;
	  		case 's': front=front_add(&front_begin,front,j,0); break;
	  	}	  	
	  }
	}
	front=front_delete(front_begin);
	for(k=i; k<3*power(2,depth); k++){ 
		free(paths[k]);
  	  	paths[k]=NULL;
  	  }
	if (i>0) front=front_delete(front_begin);
	return paths;
}


int ** findcut(int ** paths, int cutsize){
	
	int i,j;
	cut=(int**)malloc(cutsize*sizeof(int*));
	
	for(i=0; i<cutsize; i++){
      j=0;
	  while(sign_table[paths[i][j]].c!='+' && sign_table[paths[i][j]].c!='-' && sign_table[paths[i][j]].c!='s'){	  	
	  	j++;
	  }	
	  cut[i]=(int*)malloc(sizeof(int)*2);	  
	  cut[i][1]=paths[i][j-1];
	  cut[i][0]=paths[i][j];
	  
	}  

	return cut;
}


