#include <stdio.h>
#include <stdlib.h>

int ** main_table;
int vertices;
typedef struct {
	int vertex;
	struct front_item * next;
	int distance;
} FRONT_ITEM;

FRONT_ITEM * front_delete(FRONT_ITEM * begin);
FRONT_ITEM * front_add(FRONT_ITEM ** begin, FRONT_ITEM * end, int vertex, int distance);
FRONT_ITEM * front_remove(FRONT_ITEM ** begin, FRONT_ITEM ** end);
int front_contains(FRONT_ITEM * begin, int vertex);
int front_empty(FRONT_ITEM * front);
void front_print(FRONT_ITEM * begin, char * text);
int * init_vis(int * visited);

int * init_vis(int * visited){
  int i;
  for(i=0; i<vertices; i++){
	visited[i]=0;
  }  
  return visited;
}

int bfs(int vertex, int vis, int ** pole){
  FRONT_ITEM * front=NULL;
  FRONT_ITEM * front_begin=NULL;
 
  int * visited;
  
  FRONT_ITEM * pom;
  
  int i,deq,circle; 
  visited=(int*)malloc(vertices*sizeof(int)); 
  visited=init_vis(visited);
 
  if(pole!=NULL){
	
	  pole[0][0]=vis;
	  pole[0][1]=0;
	  pole[1][0]=vertex;
	  pole[1][1]=1;
  }	  
  int new_dist=0;
 visited[vis]=1;
 visited[vertex]=1;
  
  front=front_add(&front_begin,front, vertex,1);

  int j=2;  
  do{
  	pom=(front_remove(&front_begin,&front));
  	deq=pom->vertex;
    new_dist=(pom->distance)+1;
    free(pom);
  	for(i=0;i<3;i++){
  		if(main_table[i][deq]!=-1){
			if(!(visited[main_table[i][deq]])){		
				front=front_add(&front_begin,front,main_table[i][deq], new_dist);
				visited[main_table[i][deq]]=1;
				if(pole!=NULL){
				  pole[j][0]=main_table[i][deq];
				  pole[j][1]=new_dist;
				  j++;
				}
			}
			else{
			 if((main_table[i][deq]==vis) && (new_dist>2) && (pole!=NULL)){ 
			   pole[j][0]=vis;
			   pole[j++][1]=new_dist;		   
			 }
			}  		
  		}
  	}
  	circle = (new_dist>2)&&((main_table[0][deq]==vis) || (main_table[1][deq]==vis) || (main_table[2][deq]==vis));
  } while (!circle && (!front_empty(front))); 	
  front_delete(front_begin);
  free(visited);
  
  if(!circle) new_dist=32000;
  return new_dist;
}
int ** length_of_girth(int ** cut, int * cutsize){

  int i,j;
  int min=vertices,pom;
  int ** best = (int **)malloc((vertices+2)*sizeof(int*)); 
  int ** pole = (int **)malloc((vertices+2)*sizeof(int*));
  int * kruznica = (int *)malloc((vertices+2)*sizeof(int));
 
   for(i=0; i<vertices+2; i++){
	  pole[i]=(int*)malloc(2*sizeof(int));
	  pole[i][0]=-1;
	  pole[i][1]=-1;
	}
  
  for (i=0;i<vertices;i++){  	
    pom=bfs(main_table[0][i], i, pole); //pole
    if (pom<min) {
      for(j=0; j<vertices+2; j++){
      	best[j]=(int*)malloc(2*sizeof(int));
      	best[j][0]=pole[j][0];    
      	best[j][1]=pole[j][1]; 
      }
      min=pom;
    }
    
    pom=bfs(main_table[1][i], i, pole);       
    if (pom<min) {

      for(j=0; j<vertices+2; j++){
      	best[j][0]=pole[j][0];    
      	best[j][1]=pole[j][1];      	
      }
      min=pom;
    }
  }
  *cutsize=min;
  i=vertices+2;	
  int k;  
  int posledny;   
  cut=(int**)malloc(min*sizeof(int*));
    
  while(best[--i][0]!=best[0][0]); //predpokladame ze tam naozaj bola kruznica
  
  posledny=best[i][0];
  
  kruznica[0]=posledny;
  
  j=1;
  int dist=min-1;
  int sused=0;
  while((!sused) && (i>0)){
    for(k=0; k<3; k++){	
     if(main_table[k][posledny]==best[i][0] && dist==best[i][1]){ //ak      	
     	dist--;
  	    sused=1;
  	    posledny=best[i][0];
  	    kruznica[j]=posledny;  	   	   	
  	    j++;
   	 }
   }
   sused=0;
   i--;
  }
  kruznica[j]=kruznica[0]; 
  kruznica[j+1]=kruznica[1]; //kvoli hladaniu hran;
  k=j;	
  j++;
  while(j++ < vertices+2){
  	kruznica[j]=-1;
  }
  for(i=1; i<=k; i++){
  	for(j=0; j<3; j++){
  	  if(main_table[j][kruznica[i]] != kruznica[i-1] && main_table[j][kruznica[i]]!=kruznica[i+1]){
  	  	cut[i-1]=(int*) malloc (sizeof(int)*2);
  	  	cut[i-1][0]=kruznica[i];
  	  	cut[i-1][1]=main_table[j][kruznica[i]];
  	  }
  	}
  }
  
  for(i=0; i<vertices+2; i++){
  	free(pole[i]);
  	free(best[i]);
  }
  free(pole);  	
  free(kruznica);
  free(best);  
  return cut;
}
