#include <stdio.h>
#include <stdlib.h>


int power(int base, int power){
	int result=1;
	while (power--){
		result*=base;
	}
	return result;
}

typedef struct {
	int vertex;
	int distance;
} FRONT_ITEM;

int vertex_disjoint(int fulltree_a, int fulltree_b, int depth_a, int depth_b);

typedef struct {
  char c;
  int prev;
} SIGN;

int vertices;
int ** main_table;
int * flow_table[3];
SIGN * sign_table;

void print_cut(int ** cut, int cutsize, int type){
	int i;
	printf("\tedge-cut:  ");
	for(i=0; i<cutsize; i++){
	  if(type==1 || type==2)
	  	printf("%d-%d   ",cut[i][0],cut[i][1]);
	  else
	  	printf("%d-%d   ",cut[i][0]+1,cut[i][1]+1);
	}
	printf("\n");
}
int read(int type);
void main_table_free();

int ** length_of_girth(int ** cut, int * cutsize);

int ** findpaths(int fulltree_a,int fulltree_b, int depth, int ** paths);

void print_main_table();
void zeroize_flows(){
  int i,j;
  for(i=0; i<3; i++)
    for(j=0;j<vertices; j++){  		  	
     	flow_table[i][j]=0;
  }
}
int num_paths(int **paths,int max){
	int i=0;
	while(paths[i]!=NULL && i<max){
	  i++;
	}
	return i;
}

int make(int level);
int contains_edge(int b, int a, int n);
void backtrack(int level, int zac);       //kvoli testovaniu
void print_flows();
void print_signs();
int ** findcut(int ** paths, int cutsize);
int ** cut=NULL;
int num_edges;
int ** edges=NULL;
int components;
int start_level;
FILE *input;

int main(int argc, char** argv){	
   int k, i,j,depth,cutsize,order=0,pom,type=atoi(argv[3]),** paths;
   char * file;   
   vertices=atoi(argv[2]);
    if (vertices<8) {
   	 printf("Graph should have at least 8 vertices\n");
   	 return 0;
   }
   file=argv[1];   
   
 
   k=0;
	
	//kvoli nacitaniu suboru	
		  input=fopen(file, "r");
		  printf("%s: \n",file);
		  if(input){
			;
		  }
		  else{
			printf("FILE \"%s\" WAS NOT OPENED\n",file);     
		  }
	
  while(read(type)){ 	
 	
 	order++;
	
   	printf("\nGRAPH: %d\n",order);
  
 					if(edges!=NULL) {
 						for(i=0; i<num_edges; i++){					
 							free(edges[i]);
  						  }
  						  free(edges);
						}
 						
				    edges=(int**)malloc(3*vertices*sizeof(int*));					
					num_edges=3*vertices/2;
					k=0;
					for(i=0; i<vertices; i++){					
					 for(j=0;j<3; j++){  	
					   if (!contains_edge(i,main_table[j][i],k)){
						 edges[k]=(int*)malloc(2*sizeof(int));       
						 edges[k][0]=i;
						 edges[k][1]=main_table[j][i];
						 k++;						
					   }
					 }
					}
					start_level=0;
					components=0;
					
   ///////////////kvoli testovaniu
  
   for(i=0; i<3; i++){
   	flow_table[i]=(int *)malloc(vertices*sizeof(int));
   }
   zeroize_flows();
   sign_table = (SIGN *) malloc(vertices*sizeof(SIGN));
   
   for(i=0; i<vertices; i++){
   	 sign_table[i].c='x';
   	 sign_table[i].prev=-1;
   } 
   cut=NULL;
   cut=length_of_girth(cut, &cutsize);
   
   for (i=0; i<vertices; i++){
   	for (j=0; j<vertices; j++){
   	  depth=-1;
   	  do{
   	  	depth++;
   	  	zeroize_flows();
   	  	if(vertex_disjoint(i,j,depth,depth)){  
   	  	  paths=(int**) malloc (sizeof(int*)*3*power(2,depth));  	  	  	  	   	 
   	   	  for (k=0; k<3*power(2,depth); k++){
   		    paths[k]=(int*)malloc(sizeof(int)*vertices);   		    
   		  }	 
   		  paths=findpaths(i,j,depth,paths);
   	   	  pom=num_paths(paths,3*power(2,depth)) ;
   	   	  
   	   	   if (pom<3*power(2,depth) && pom < cutsize){
   	   	 	  if(cut!=NULL) {
   	   	 	  	for (k=0; k<cutsize; k++){
   	   	 	  		free(cut[k]);
   	   	 	  	}   	   	 	  	
   	   	 	  	free(cut); 
   	   	 	  }
   	   	 	  cutsize=pom;  
   	   	 	  
   	   	 	  cut=findcut(paths,cutsize);
   	   	   }   	   
   	  	}
   	  	else{
   	   	 break;
   	  	}
   	      for (k=0; k<3*power(2,depth); k++){
   		    if(paths[k]!=NULL) free(paths[k]);
   	      }  	 
   		  free(paths);
   	  }while (3*power(2,depth) < cutsize);	
   	   
   	   }
   	 }   	 
   	 printf("\tcyclic edge connectivity: %d\n",cutsize);   	 
     print_cut(cut,cutsize,type);
   	 start_level=0;
	 components=0;	 
   	 do{   	 	
		start_level++;
		backtrack(start_level,0);					
	 }
	 while(start_level<10 && components<2);     //start_level je vlastne suvislost cykl.  	 
	 
  	 if(start_level==cutsize){
  	 	for (k=0; k<cutsize; k++){  //odznacenie;
  	 		for(j=0; j<3; j++){
  	 			if(main_table[j][cut[k][0]]==cut[k][1]) main_table[j][cut[k][0]]=-1;
  	 			if(main_table[j][cut[k][1]]==cut[k][0]) main_table[j][cut[k][1]]=-1;
  	 		}  	   	 		
  	 	}
    	//printf("\n");
  	 	components=0;
  	 	
    	if (make(start_level)==2){	
  	 		printf("test OK\n");
  	 	}
  	 	else 
  	 		printf("PROBLEM: cut is not cyclic\n");
  	
   	 }
  	else printf("PROBLEM: size of cyclic edge connectivity is incorrect\n");
  	main_table_free();
   
  
  
  }
  fclose(input);
  
  if(cut!=NULL) {
  	for (k=0; k<cutsize; k++){
   	  free(cut[k]);
   	 }   	   	 	  	
   	free(cut); 
  }
 
  return 0;
}
