#include <stdio.h>
#include <stdlib.h>

typedef struct front_item{
	int vertex;
	struct front_item * next;
	int distance;
} FRONT_ITEM;
int * init_vis(int * visited);
void print_main_table();
int bfs(int vertex, int vis, int ** pole);
int front_empty(FRONT_ITEM * front);
void front_print(FRONT_ITEM * begin, char * text);
FRONT_ITEM * front_add(FRONT_ITEM ** begin, FRONT_ITEM * end, int vertex, int distance);
FRONT_ITEM * front_remove(FRONT_ITEM ** begin, FRONT_ITEM ** end);
FRONT_ITEM * front_delete(FRONT_ITEM * begin);
int front_contains(FRONT_ITEM * begin, int vertex);
void nacitaj(char * file, int ktory, int dokopy);
int ** main_table;
int *** vsetky;
int vertices;
int num_edges;
int ** edges;
int components;
int start_level;

void mark(int i, int ** pom){
	int j;
	(*pom)[0]=edges[i][0];
	(*pom)[1]=edges[i][1];
	for(j=0; j<3; j++){
	  if( main_table[j][(*pom)[0]] == (*pom)[1] )
	  	main_table[j][(*pom)[0]]=-1;	    
	}
	
	for(j=0; j<3; j++){
	  if( main_table[j][(*pom)[1]] == (*pom)[0] )
	  	main_table[j][(*pom)[1]]=-1;	    
	}
		
}
int make(int level){
	int c=0;	
	int * visited=NULL;	
	FRONT_ITEM * front=NULL;
	FRONT_ITEM * copy=NULL;
	FRONT_ITEM * front_begin;
	FRONT_ITEM * copy_begin;
	FRONT_ITEM * pom;
	int prvy_sused;
	int i,j,deq,circle=32000,circle2;
	
	visited=(int*)malloc(vertices*sizeof(int)); 
  	visited=init_vis(visited);
	
	for(i=0; i<vertices; i++){
	  prvy_sused=-1;
	  if(!(visited[i])){
	  	
	  	visited[i]=1;
		front=front_add(&front_begin,front, i,1);
		copy=front_add(&copy_begin, copy, i,1);
  		do{  
  			pom=(front_remove(&front_begin,&front));
  			deq=pom->vertex;
  			free(pom);
  			
  		  for(j=0;j<3;j++){
  			
  				if(!(visited[main_table[j][deq]]) && main_table[j][deq]!=-1){		
  					front=front_add(&front_begin,front,main_table[j][deq], 1);
  					copy=front_add(&copy_begin,copy,main_table[j][deq], 1);
  			
  					visited[main_table[j][deq]]=1;
  					if(prvy_sused==-1){
  						prvy_sused=main_table[j][deq];
  					}
  				}
  		  }	
		}while(!front_empty(front));
		
			while(!front_empty(copy)){
				pom=(front_remove(&copy_begin,&copy));
				deq=pom->vertex;
				free(pom);				
  				j=0;
  				while(j<3 && main_table[j][deq]==-1) j++;
  				if(j<3){
  					circle2=bfs(deq,main_table[j][deq],NULL);
  					if  (circle2<circle) circle=circle2;
  					j++;
  				}
  				while(j<3 && main_table[j][deq]==-1) j++;
  				if(j<3){
  					circle2=bfs(deq,main_table[j][deq],NULL);
  					if (circle2<circle) circle=circle2;
  				}
  					
  			}
			if (circle<32000){				
				c++;
			}
			circle=32000;
	
		front=front_delete(front_begin);
		copy=front_delete(copy_begin);
	  }
 	  
	}
	free(visited);
	return c;
}
void unmark(int i, int ** pom){
	int j=0;
	while(main_table[j][(*pom)[0]] != -1){	  	   
	  j++;
	}
	main_table[j][(*pom)[0]]=(*pom)[1];
	j=0;
	while( main_table[j][(*pom)[1]] != -1){	  
	  j++;    
	}
	main_table[j][(*pom)[1]]=(*pom)[0];	
}


void backtrack(int level, int zac){
	int i,c;
	int * pom;
	pom=(int*)malloc(sizeof(int)*2);
	for(i=zac; i<num_edges-level+1;i++){
		mark(i, &pom);
		if (level>1){
			 backtrack(level-1,i+1);}
		else {
		  c=make(level);
		  if(c>components) 
		  	components=c;
		}
		unmark(i, &pom);		
			
	} 
	free(pom); 
}
void print_edges(){
	int i;
	for(i=0; i<num_edges; i++){
		printf("%d : %d\n",edges[i][0],edges[i][1]);
	}
}
int contains_edge(int b, int a, int n){
	int i, ret=0;
    for (i=0; i<n; i++){
  	  ret=ret || (edges[i][0]==a && edges[i][1]==b);	
  	} 
  	return ret;  
}

