#include <stdio.h>
#include <stdlib.h>


int power(int base, int power){
	int result=1;
	while (power--){
		result*=base;
	}
	return result;
}

typedef struct {
	int vertex;
	int distance;
} FRONT_ITEM;

int vertex_disjoint(int fulltree_a, int fulltree_b, int depth_a, int depth_b);

typedef struct {
  char c;
  int prev;
} SIGN;

int vertices;
int ** main_table;
int * flow_table[3];
SIGN * sign_table;

void print_cut(int ** cut, int cutsize){
	int i;
	printf("\tedge-cut:  ");
	for(i=0; i<cutsize; i++){
		
	  printf("%d-%d   ",cut[i][0],cut[i][1]);
	}
	printf("\n");
}
int read(int type);
void main_table_free();

int ** length_of_girth(int ** cut, int * cutsize);

int ** findpaths(int fulltree_a,int fulltree_b, int depth, int ** paths);

void print_main_table();
void zeroize_flows(){
  int i,j;
  for(i=0; i<3; i++)
    for(j=0;j<vertices; j++){  		  	
     	flow_table[i][j]=0;
  }
}
int num_paths(int **paths,int max){
	int i=0;
	while(paths[i]!=NULL && i<max){
	  i++;
	}
	return i;
}

int make(int level);
int contains_edge(int b, int a, int n);
void backtrack(int level, int zac);       //kvoli testovaniu
void print_flows();
void print_signs();
int ** findcut(int ** paths, int cutsize);
int ** cut=NULL;
int num_edges;
int ** edges=NULL;
int components;
int start_level;
FILE *input;
int main(int argc, char** argv){	
   int k, i,j,cutsize,order=0,type=atoi(argv[3]);
   char * file;   
   vertices=atoi(argv[2]);
    if (vertices<8) {
   	 printf("Graph should have at least 8 vertices\n");
   	 return 0;
   }
   file=argv[1];   
   
 
   k=0;
	
	//kvoli nacitaniu suboru	
		  input=fopen(file, "r");
		  printf("%s: \n",file);
		  if(input){
			;
		  }
		  else{
			printf("FILE \"%s\" WAS NOT OPENED\n",file);     
		  }
	
 while(read(type)){
 	
 	order++;
	
   	printf("\nGRAPH: %d\n",order);
  
 					if(edges!=NULL) {
 						for(i=0; i<num_edges; i++){					
 							free(edges[i]);
  						  }
  						  free(edges);
						}
						 						
				    edges=(int**)malloc(3*vertices*sizeof(int*));					
					num_edges=3*vertices/2;
					k=0;
					for(i=0; i<vertices; i++){					
					 for(j=0;j<3; j++){  	
					   if (!contains_edge(i,main_table[j][i],k)){
						 edges[k]=(int*)malloc(2*sizeof(int));       
						 edges[k][0]=i;
						 edges[k][1]=main_table[j][i];
						 k++;						
					   }
					 }
					}
					start_level=0;
					components=0;
					
     
   	 start_level=0;
	 components=0;	 
   	 do{   	 	
		start_level++;
		backtrack(start_level,0);					
	 }
	 while(start_level<32000 && components<2);
	 printf("cyclic edge connectivity: %d\n",start_level);
  	
  	main_table_free();
   
  
  
  }
  fclose(input);
  
  if(cut!=NULL) {
  	for (k=0; k<cutsize; k++){
   	  free(cut[k]);
   	 }   	   	 	  	
   	free(cut); 
  }
 
  return 0;
}

